GNU bug report logs - #32943
grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: grep; Reported by: Houder <houder@HIDDEN>; dated Fri, 5 Oct 2018 10:15:01 UTC; Maintainer for grep is bug-grep@HIDDEN.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 9 Oct 2018 11:29:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 09 07:29:46 2018
Received: from localhost ([127.0.0.1]:41258 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g9qCw-00005O-9Q
	for submit <at> debbugs.gnu.org; Tue, 09 Oct 2018 07:29:46 -0400
Received: from lb3-smtp-cloud8.xs4all.net ([194.109.24.29]:48162)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g9qCq-00004s-Sx
 for 32943 <at> debbugs.gnu.org; Tue, 09 Oct 2018 07:29:44 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:199])
 by smtp-cloud8.xs4all.net with ESMTPA
 id 9qCkguAbP0ZZE9qCkgBBo8; Tue, 09 Oct 2018 13:29:34 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Tue, 09 Oct 2018 13:29:34 +0200
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII;
 format=flowed
Content-Transfer-Encoding: 7bit
Date: Tue, 09 Oct 2018 13:29:34 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
In-Reply-To: <8e683845f7535ff195d2bc3728592b9d@HIDDEN>
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
 <7b08a209ff9d3bea6d14f5d31d167fe5@HIDDEN>
 <7b98e186-a394-3c83-0a45-b419ec3c2fec@HIDDEN>
 <8e683845f7535ff195d2bc3728592b9d@HIDDEN>
Message-ID: <086a811781cf64c868d41e155b94af47@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfLGOxhzvt8FCiLbWe/fqyfdZU1JDSEqYYKNY+T+5drZ5Q/7ye5pVMIpBKW0OSmJgtqFyuWoCUCOE8aQ+24icGPLfGPXOryHzKu2/DMC+vAPbS6waj61V
 Iv0vi1KKjVxPdRu4YKz/ktAQlM35RcmQT8JxnZKxDp58v0QN3PTYs5pb8NAifQJUzg8YWvYGGHISJ/eSEJeSeDWPkwqCsfZgG/c=
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2018-10-08 20:10, Houder wrote:
[snip]

> Here NtQueryInformationFile() is called, which fails with

s/ NtQueryInformationFile / NtSetInformationFile /

Set! Not Query.

> ERROR_INVALID_PARAMETER (87), which Cygwin turns into EINVAL (22).
> 
> We have to wait until Corinna Vinschen returns from holidays (end of
> october), because Corinna Vinschen is the only one who can deal with
> the executive.

correcting myself in order NOT to submit INcorrect info to the list.

-----




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 8 Oct 2018 18:10:43 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 08 14:10:43 2018
Received: from localhost ([127.0.0.1]:40737 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g9ZzP-00009Y-3b
	for submit <at> debbugs.gnu.org; Mon, 08 Oct 2018 14:10:43 -0400
Received: from lb2-smtp-cloud9.xs4all.net ([194.109.24.26]:53349)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g9ZzO-00009K-5P
 for 32943 <at> debbugs.gnu.org; Mon, 08 Oct 2018 14:10:42 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:216])
 by smtp-cloud9.xs4all.net with ESMTPA
 id 9ZzHgQsV8SskC9ZzHgilqA; Mon, 08 Oct 2018 20:10:36 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Mon, 08 Oct 2018 20:10:35 +0200
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII;
 format=flowed
Content-Transfer-Encoding: 7bit
Date: Mon, 08 Oct 2018 20:10:35 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
In-Reply-To: <7b98e186-a394-3c83-0a45-b419ec3c2fec@HIDDEN>
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
 <7b08a209ff9d3bea6d14f5d31d167fe5@HIDDEN>
 <7b98e186-a394-3c83-0a45-b419ec3c2fec@HIDDEN>
Message-ID: <8e683845f7535ff195d2bc3728592b9d@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfGbKsJFkzhXOp/evnWItgi+zpLpgoRxO1wYQc3PE8Qh8L2aL3TvkP3PUCGw3CzmwmB5E0z3zEGTFkXIb5PuFzp7aWRMLGQ2f2+Twxv4OYnH3AxPvILPs
 8iWxvJXb31Itc2cc2Heo61MWKyEMiSQi82Dp4yLKBQT2mChF9rq+DZoSSL8Oiy2EaFljtmemww69eLmEfiZvGm/6aOLE6b1s29Ekd6cXoi47T2JHt9Z2sgLk
 4q40NnoOOpHcXWWn/6mnBQ==
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 32943
Cc: Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2018-10-08 17:49, Paul Eggert wrote:
> On 10/8/18 12:35 AM, Houder wrote:
>> grep terminates with an error on Cygwin because lseek() on Cygwin 
>> fails to
>> ascertain that it is applied to a FIFO.
> 
> 
> That sounds like a bug in Cygwin, then. Can you find out exactly why
> it occurs, by using GDB within Cygwin? Then you can file a bug report
> with the Cygwin folks.

Yes, it _is_ a bug in cywin1.dll (i.e. the executive). No, I cannot find
out _exactly_ why it occurs (see below). A "bug report" has been filed,

Cygwin has no official bug tracker. A bug is reported on the 
mailinglist.

I have reported my findings here:

     https://cygwin.com/ml/cygwin/2018-10/msg00062.html

E. Blake, one of members on your list, has already acknowledged that the
Cygwin executive must be fixed.

> Possibly the bug is something like the following: grep calls lseek
> (fd, 0, SEEK_CUR). The Cygwin lseek implementation asks MS-Windows
> what the file offset is, gets an error because the file descriptor is
> that of a pipe, and somehow turns that into EINVAL. Cygwin should turn
> it into ESPIPE instead.

Cygwin has been written in C++ (it would take me a very long time to get
familiar with the implementation).

lseek() is implemented in winsup/cygwin/syscalls.cc. The "real" lseek()
however is implemented in one of the many "handlers", depending on the
device type on which lseek() is applied (I am guessing).

Apparently, "nothing" has been implemented for a fifo, and as result
of that the basic handler fhandler_base::lseek() in

     winsup/cygwin/fhandler.cc (1031) is invoked.

Here NtQueryInformationFile() is called, which fails with

ERROR_INVALID_PARAMETER (87), which Cygwin turns into EINVAL (22).

We have to wait until Corinna Vinschen returns from holidays (end of
october), because Corinna Vinschen is the only one who can deal with
the executive.

Regards,
Henri










Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 8 Oct 2018 15:49:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 08 11:49:33 2018
Received: from localhost ([127.0.0.1]:40667 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g9Xmn-0005CE-Gj
	for submit <at> debbugs.gnu.org; Mon, 08 Oct 2018 11:49:33 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:49392)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1g9Xml-0005By-HH
 for 32943 <at> debbugs.gnu.org; Mon, 08 Oct 2018 11:49:32 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 7674B1616DE;
 Mon,  8 Oct 2018 08:49:25 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id 8-en071TjpXo; Mon,  8 Oct 2018 08:49:24 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id BAF021616E0;
 Mon,  8 Oct 2018 08:49:24 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id lsgBUJ5mPbGy; Mon,  8 Oct 2018 08:49:24 -0700 (PDT)
Received: from Penguin.CS.UCLA.EDU (Penguin.CS.UCLA.EDU [131.179.64.200])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id A1B741616DF;
 Mon,  8 Oct 2018 08:49:24 -0700 (PDT)
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
To: Houder <houder@HIDDEN>, 32943 <at> debbugs.gnu.org
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
 <7b08a209ff9d3bea6d14f5d31d167fe5@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Openpgp: preference=signencrypt
Autocrypt: addr=eggert@HIDDEN; prefer-encrypt=mutual; keydata=
 xsFNBEyAcmQBEADAAyH2xoTu7ppG5D3a8FMZEon74dCvc4+q1XA2J2tBy2pwaTqfhpxxdGA9
 Jj50UJ3PD4bSUEgN8tLZ0san47l5XTAFLi2456ciSl5m8sKaHlGdt9XmAAtmXqeZVIYX/UFS
 96fDzf4xhEmm/y7LbYEPQdUdxu47xA5KhTYp5bltF3WYDz1Ygd7gx07Auwp7iw7eNvnoDTAl
 KAl8KYDZzbDNCQGEbpY3efZIvPdeI+FWQN4W+kghy+P6au6PrIIhYraeua7XDdb2LS1en3Ss
 mE3QjqfRqI/A2ue8JMwsvXe/WK38Ezs6x74iTaqI3AFH6ilAhDqpMnd/msSESNFt76DiO1ZK
 QMr9amVPknjfPmJISqdhgB1DlEdw34sROf6V8mZw0xfqT6PKE46LcFefzs0kbg4GORf8vjG2
 Sf1tk5eU8MBiyN/bZ03bKNjNYMpODDQQwuP84kYLkX2wBxxMAhBxwbDVZudzxDZJ1C2VXujC
 OJVxq2kljBM9ETYuUGqd75AW2LXrLw6+MuIsHFAYAgRr7+KcwDgBAfwhPBYX34nSSiHlmLC+
 KaHLeCLF5ZI2vKm3HEeCTtlOg7xZEONgwzL+fdKo+D6SoC8RRxJKs8a3sVfI4t6CnrQzvJbB
 n6gxdgCu5i29J1QCYrCYvql2UyFPAK+do99/1jOXT4m2836j1wARAQABzSBQYXVsIEVnZ2Vy
 dCA8ZWdnZXJ0QGNzLnVjbGEuZWR1PsLBfgQTAQIAKAUCTIByZAIbAwUJEswDAAYLCQgHAwIG
 FQgCCQoLBBYCAwECHgECF4AACgkQ7ZfpDmKqfjRRGw/+Ij03dhYfYl/gXVRiuzV1gGrbHk+t
 nfrI/C7fAeoFzQ5tVgVinShaPkZo0HTPf18x6IDEdAiO8Mqo1yp0CtHmzGMCJ50o4Grgfjlr
 6g/+vtEOKbhleszN2XpJvpwM2QgGvn/laTLUu8PH9aRWTs7qJJZKKKAb4sxYc92FehPu6FOD
 0dDiyhlDAq4lOV2mdBpzQbiojoZzQLMQwjpgCTK2572eK9EOEQySUThXrSIz6ASenp4NYTFH
 s9tuJQvXk9gZDdPSl3bp+47dGxlxEWLpBIM7zIONw4ks4azgT8nvDZxA5IZHtvqBlJLBObYY
 0Le61Wp0y3TlBDh2qdK8eYL426W4scEMSuig5gb8OAtQiBW6k2sGUxxeiv8ovWu8YAZgKJfu
 oWI+uRnMEddruY8JsoM54KaKvZikkKs2bg1ndtLVzHpJ6qFZC7QVjeHUh6/BmgvdjWPZYFTt
 N+KA9CWX3GQKKgN3uu988yznD7LnB98T4EUH1HA/GnfBqMV1gpzTvPc4qVQinCmIkEFp83zl
 +G5fCjJJ3W7ivzCnYo4KhKLpFUm97okTKR2LW3xZzEW4cLSWO387MTK3CzDOx5qe6s4a91Zu
 ZM/j/TQdTLDaqNn83kA4Hq48UHXYxcIh+Nd8k/3w6lFuoK0wrOFiywjLx+0ur5jmmbecBGHc
 1xdhAFHOwU0ETIByZAEQAKaF678T9wyH4wjTrV1Pz3cDEoSnV/0ZUrOT37p1dcGyj/IXq1x6
 70HRVahAmk0sZpYc25PF9D5GPYHFWlNjuPU96rDndXB3hedmBRhLdC4bAXjI4DV+bmdVe+q/
 IMnlZRaVlm9EiMCVAR6w13sReu7qXkW9r3RwY2AzXskp/tAe4BRKr1Zmbvi2nbnQ6epEC42r
 Rbx0B1EhjbIQZ5JHGk24iPT7LdBgnNmos5wYjzwNlkMQD5T0Ydzhk7J+UxwA5m46mOhRDC2r
 FV/A0gm5TLy8DXjv/Esc4gYnYai6SQqnUEVh5LuV8YCJBnijs+Tiw71x1icmn6xGI45EugJO
 gec+rLypYgpVp4x0HI5T88qBRYCkxH3Kg8Qo+EWNA9A4LRQ9DX8njona0gf0s03tocK8kBN6
 6UoqqPtHBnc4eMgBymCflK12eKfd2YYxnyg9cZazWA5VslvTxpm76hbg5oiAEH/Vg/8MxHyA
 nPhfrgwyPrmJEcVBafdspJnYQxBYNco2LFPIhlOvWh8r4at+s+M3Lb26oUTczlgdW1Sf3SDA
 77BMRnF0FQyE+7AzV79MBN4ykiqaezQxtaF1Fy/tvkhffSo8u+dwG0EgJh+te38gTcISVr0G
 IPplLz6YhjrbHrPRF1CN5UuL9DBGjxuN35RLNVEfta6RUFlR6NctTjvrABEBAAHCwWUEGAEC
 AA8FAkyAcmQCGwwFCRLMAwAACgkQ7ZfpDmKqfjSrHA/+KzAKvTxRhA9MWNLxIyJ7S5uJ16gs
 T3oCjZrBKGEhKMOGX4O0GA6VOEryO7QRCCYah3oxSG38IAnNeiwJXgU9Bzkk85UGbPEd7HGF
 /VSeHCQwWou6jqUDTSDvn9YhNTdG0KXPM74aC+xr2Zow1O2mhXihgWKD0Dw+0LYPnUOsQ0KO
 FxHXXYHmRrS1OZPU59BLvc+TRhIhafSHKLwbXK+6ckkxBx6h8z5ccpG0Qs4bFhdFYnFrEieD
 LoGmnE2YLhdV6swJ9VNCS6pLiEohT3fm7aXm15tZOIyzMZhHRSAPblXxQ0ZSWjq8oRrcYNFx
 c4W1URpAkBCOYJoXvQfD5L3lqAl8TCqDUzYxhH/tJhbDdHrqHH767jaDaTB1+Talp/2AMKwc
 XNOdiklGxbmHVG6YGl6g8Lrbsu9NZEI4yLlHzuikthJWgz+3vZhVGyNlt+HNIoF6CjDL2omu
 5cEq4RDHM44QqPk6l7O0pUvN1mT4B+S1b08RKpqm/ff015E37HNV/piIvJlxGAYz8PSfuGCB
 1thMYqlmgdhd9/BabGFbGGYHA6U4/T5zqU+f6xHy1SsAQZ1MSKlLwekBIT+4/cLRGqCHjnV0
 q5H/T6a7t5mPkbzSrOLSo4puj+IToNjYyYIDBWzhlA19avOa+rvUjmHtD3sFN7cXWtkGoi8b
 uNcby4U=
Organization: UCLA Computer Science Department
Message-ID: <7b98e186-a394-3c83-0a45-b419ec3c2fec@HIDDEN>
Date: Mon, 8 Oct 2018 08:49:24 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:60.0) Gecko/20100101
 Thunderbird/60.0
MIME-Version: 1.0
In-Reply-To: <7b08a209ff9d3bea6d14f5d31d167fe5@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 7bit
Content-Language: en-US
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 10/8/18 12:35 AM, Houder wrote:
> grep terminates with an error on Cygwin because lseek() on Cygwin 
> fails to
> ascertain that it is applied to a FIFO. 


That sounds like a bug in Cygwin, then. Can you find out exactly why it 
occurs, by using GDB within Cygwin? Then you can file a bug report with 
the Cygwin folks.

Possibly the bug is something like the following: grep calls lseek (fd, 
0, SEEK_CUR). The Cygwin lseek implementation asks MS-Windows what the 
file offset is, gets an error because the file descriptor is that of a 
pipe, and somehow turns that into EINVAL. Cygwin should turn it into 
ESPIPE instead.





Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 8 Oct 2018 07:35:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Oct 08 03:35:49 2018
Received: from localhost ([127.0.0.1]:39858 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g9Q4y-0000OG-U7
	for submit <at> debbugs.gnu.org; Mon, 08 Oct 2018 03:35:49 -0400
Received: from lb1-smtp-cloud7.xs4all.net ([194.109.24.24]:59596)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g9Q4x-0000O3-Pj
 for 32943 <at> debbugs.gnu.org; Mon, 08 Oct 2018 03:35:48 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:195])
 by smtp-cloud7.xs4all.net with ESMTPA
 id 9Q4qgrkcfw2L89Q4qgLRn5; Mon, 08 Oct 2018 09:35:41 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Mon, 08 Oct 2018 09:35:40 +0200
MIME-Version: 1.0
Content-Type: multipart/mixed;
 boundary="=_a8a60ddb5c27287c591626bcfbeef3a1"
Date: Mon, 08 Oct 2018 09:35:40 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
In-Reply-To: <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
Message-ID: <7b08a209ff9d3bea6d14f5d31d167fe5@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfNvg34cFrUI3Z5M6KkIUwo0T7ZSYQVXQm93RK4nvJuBwFYMJjQbT7aweY0ER8SWxNlrOnAfoCWYO8m67EwSnrRQDVDoftktvRyHL2hd9pHMnT96NDIIm
 2OybO6cZVEonw11nAV5ASxz/u8gFYfq0eqAnBtTlr23TPKNKven1TK9So/nxpbYI67spL6TLR4YxB+4qaIYT6Z0iTcuOcQs9PstwkCEu3t1GyS1YKEOm9w/P
 jXycpNoAUbHbut8T/tnsgg==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 32943
Cc: Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=_a8a60ddb5c27287c591626bcfbeef3a1
Content-Transfer-Encoding: 7bit
Content-Type: text/plain; charset=US-ASCII;
 format=flowed

On 2018-10-06 22:12, Paul Eggert wrote:
[snip}

> My guess is that you've got an old version of grep on Cygwin, and need
> to upgrade to the current version. If you still have problems with the
> latest version, please investigate via GDB and/or other means exactly
> why grep is failing for you ...

Hi Paul,

I have found what causes grep to fail. (after building v3.1 of grep)

But in order not to mislead others reading this thread, I must correct 
what I
wrote in my initial post. There I wrote: "as far as I can tell, the code 
that
is executed on Cygwin is not the same as the one that is executed on 
Linux".

Wrong. My "strace-ing" misled me.

Returning to grep's failure on Gygwin:

grep terminates with an error on Cygwin because lseek() on Cygwin fails 
to
ascertain that it is applied to a FIFO.

As result Cygwin's executive returns EINVAL in errno, in stead of 
ESPIPE, as
required (my interpretation after reading "man 2 lseek").

ESPIPE is expected in reset() (src/grep.c), after lseek() has been 
applied to
stdin (which points to a FIFO here).

Until v2.26 of grep, a call to S_ISREG(st->st_mode) circumvented the 
call to
lseek() (and the call to suppressible_error()) and made reset() return 
true.

Version v2.27 of grep removed the call to S_ISREG(st->st_mode). As 
result of
that lseek() is invoked.

lseek() fails, but an exception is made for errno == ESPIPE. For this 
reason
grep does not fail on Linux (reset() returns true).

However on Cygwin, suppressible_error() is called and reset() returns 
false,
which makes grep fail on Cygwin.

You can see for yourself in the attached logfiles (GDB sessions).

-----
To what did I apply GDB?

  - downloaded the tarball (grep-3.1.tar.xz) from 
http://ftp.gnu.org/gnu/grep/
  - build grep using "make CFLAG='-O -g3'", both on Linux and Cygwin

Regards,
Henri
--=_a8a60ddb5c27287c591626bcfbeef3a1
Content-Transfer-Encoding: base64
Content-Type: text/plain;
 name=gdb-cygwin.log
Content-Disposition: attachment;
 filename=gdb-cygwin.log;
 size=1766
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=
--=_a8a60ddb5c27287c591626bcfbeef3a1
Content-Transfer-Encoding: base64
Content-Type: text/plain;
 name=gdb-linux.log
Content-Disposition: attachment;
 filename=gdb-linux.log;
 size=1500
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--=_a8a60ddb5c27287c591626bcfbeef3a1--




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 7 Oct 2018 08:23:51 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Oct 07 04:23:51 2018
Received: from localhost ([127.0.0.1]:39024 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g94Lu-0007Ew-Iq
	for submit <at> debbugs.gnu.org; Sun, 07 Oct 2018 04:23:50 -0400
Received: from lb2-smtp-cloud9.xs4all.net ([194.109.24.26]:33419)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g94Lr-0007Eg-Tp
 for 32943 <at> debbugs.gnu.org; Sun, 07 Oct 2018 04:23:49 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:199])
 by smtp-cloud9.xs4all.net with ESMTPA
 id 94LlggdnowD1894Llg4WzF; Sun, 07 Oct 2018 10:23:41 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Sun, 07 Oct 2018 10:23:41 +0200
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII;
 format=flowed
Content-Transfer-Encoding: 7bit
Date: Sun, 07 Oct 2018 10:23:41 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
In-Reply-To: <144d8f4b-9da6-f00b-f4d8-22cafd8fbe65@HIDDEN>
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
 <c222859e8646a09b91eb5bff8ca18843@HIDDEN>
 <144d8f4b-9da6-f00b-f4d8-22cafd8fbe65@HIDDEN>
Message-ID: <f5051225fd84a3b27cdf1a7ffdaced81@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfOU7f4ePK9w+Jc/CLttx+EUgOb+U6QwQWxqUlVH51ps8RGR5LtlXYUrzZI3jImuxANOg2K2bYirjDYJieWWBUQIX+3EFnEMc18i9oSpMFL+sKbuazHYK
 HRHS8E03ZWGc3PYMwIb1oOc8CZGtKznxHSpz0F4j9IByZAcNWo5lucrRrpTZH6Mc7TAn2Zez4HFxpJL2OqVEMLe2IwKtQvtDBrs=
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2018-10-07 01:45, Paul Eggert wrote:
[snip]

> Try running grep as follows
> 
> $ gdb src/grep
> ...
> (gdb) run . < fifo

For those reading this thread:

  - 
https://stackoverflow.com/questions/9031554/gdb-input-redirection-using-cygwin
    ( gdb input redirection using cygwin )

     "It seems that input redirection in gdb does not work in Cygwin e.g

      (gdb) run < input.txt

      Is there other way to redirect input in gdb of Cygwin?"

-----




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 6 Oct 2018 23:45:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 06 19:45:55 2018
Received: from localhost ([127.0.0.1]:38919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g8wGh-00032A-Ed
	for submit <at> debbugs.gnu.org; Sat, 06 Oct 2018 19:45:55 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:53178)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1g8wGf-00031x-No
 for 32943 <at> debbugs.gnu.org; Sat, 06 Oct 2018 19:45:54 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 77D4816161C;
 Sat,  6 Oct 2018 16:45:47 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id USbp050K-0KJ; Sat,  6 Oct 2018 16:45:46 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id BDB1716162D;
 Sat,  6 Oct 2018 16:45:46 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id 3SndW-ybxLPI; Sat,  6 Oct 2018 16:45:46 -0700 (PDT)
Received: from [192.168.1.9] (cpe-23-242-74-103.socal.res.rr.com
 [23.242.74.103])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 9C33616161C;
 Sat,  6 Oct 2018 16:45:46 -0700 (PDT)
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
To: Houder <houder@HIDDEN>, 32943 <at> debbugs.gnu.org
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
 <c222859e8646a09b91eb5bff8ca18843@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <144d8f4b-9da6-f00b-f4d8-22cafd8fbe65@HIDDEN>
Date: Sat, 6 Oct 2018 16:45:46 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.9.1
MIME-Version: 1.0
In-Reply-To: <c222859e8646a09b91eb5bff8ca18843@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Houder wrote:

> Old version? The version used by Cygwin is based on 3.0. As far as I ca=
n
> tell, the most recent tarball is 3.1 ?????

Yes, that's the most recent release.

When building grep 3.1 for use with GDB, I suggest turning off optimizati=
on.=20
Something like this:

make clean
make CFLAGS=3D'-g3'

> I did investigate using gdb and had a hard time getting a useful result
> because of the indirection (grep . < fifo).

Try running grep as follows

$ gdb src/grep
...
(gdb) run . < fifo

> (gdb) bt
> #0=C2=A0 suppressible_error (errnum=3D22) at /usr/src/debug/grep-3.0-2/=
src/grep.c:595
...
That stack trace is coming from grep 3.0. Please debug grep 3.1 instead.




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 6 Oct 2018 21:03:13 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 06 17:03:13 2018
Received: from localhost ([127.0.0.1]:38885 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g8tjF-0007ev-8Z
	for submit <at> debbugs.gnu.org; Sat, 06 Oct 2018 17:03:13 -0400
Received: from lb3-smtp-cloud8.xs4all.net ([194.109.24.29]:39628)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g8tjD-0007eh-Dw
 for 32943 <at> debbugs.gnu.org; Sat, 06 Oct 2018 17:03:11 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:199])
 by smtp-cloud8.xs4all.net with ESMTPA
 id 8tj6gY5Eu0ZZE8tj6gx9F7; Sat, 06 Oct 2018 23:03:05 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Sat, 06 Oct 2018 23:03:04 +0200
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII;
 format=flowed
Content-Transfer-Encoding: 7bit
Date: Sat, 06 Oct 2018 23:03:04 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
In-Reply-To: <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
 <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
Message-ID: <c222859e8646a09b91eb5bff8ca18843@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfE9uS9Z5aIvdlIJ4L7UuoXDdPLDwTFh29MU2YWvdSfglj6fuI8gtfnttq6uGSKVQK+SlSlSaCvBCCEFKLk8t/Hm5sqlU2odv8rxFbwUCJNV7pL0iKP56
 1FDoOzJTq571lcI8XBXlBN0M9ni4Ltw6CJyr4K9N+xklunEWY15rOD129uAJijLEWHCiFGRNJvKluS/UGXO6xvAi6tgGcaasy9tIMtcqBbkSHHrEQU94/dDM
 M2obWCN6bJz+6sIotQ4TLA==
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 32943
Cc: Paul Eggert <eggert@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On 2018-10-06 22:12, Paul Eggert wrote:
> Houder wrote:
>> I applied strace to "grep . < fifo", and as far as I can tell "an 
>> lseek
>> is applied to the fifo", which obviously fails.
>> 
>> The "lseek" occurs on Cygwin (and MinGW?), but not on Linux
> 
> That's expected, as the code needs to run lseek in some places on
> Cygwin where it's not needed on GNU/Linux.
> 
> My guess is that you've got an old version of grep on Cygwin, and need
> to upgrade to the current version. If you still have problems with the
> latest version, please investigate via GDB and/or other means exactly
> why grep is failing for you. The strace output isn't enough,
> unfortunately.

Hi Paul,

Thanks for the reply! (I know now that "the list" is aware my post :-)

(and yes, in the mean time I have found plenty of URLs pointing to the
  project and the bug-tracker)

My reply is to the list, CC to you. (or should I only reply to the 
list?)

Old version? The version used by Cygwin is based on 3.0. As far as I can
tell, the most recent tarball is 3.1 ?????

I did investigate using gdb and had a hard time getting a useful result
because of the indirection (grep . < fifo).

After searching the internet, I proceeded as follows:

@@ gdb /usr/bin/grep

This also loads the symbol table on Cygwin.

(gdb) set args .
(gdb) br main
(gdb) run

GDB stops at main()

(gdb) p dup2(open("fifo", 0), 0)

Next I execute "echo aaa > fifo" from another terminal; this makes GDB
return to the prompt (the prompt did not return after the above dup2()).

Subsequently I put a breakpoint on suppressible_error().

When the excution hits the breakpoint, I got this stack trace:

(gdb) bt
#0  suppressible_error (errnum=22) at 
/usr/src/debug/grep-3.0-2/src/grep.c:595
#1  0x0000000100403f05 in grep (ineof=<synthetic pointer>, 
st=0xffffc890, fd=0) at /usr/src/debug/grep-3.0-2/src/grep.c:1480
#2  grepdesc (desc=desc@entry=0, command_line=command_line@entry=true) 
at /usr/src/debug/grep-3.0-2/src/grep.c:1875
#3  0x0000000100428f74 in grep_command_line_arg (arg=<optimized out>) at 
/usr/src/debug/grep-3.0-2/src/grep.c:1915
#4  main (argc=<optimized out>, argv=<optimized out>) at 
/usr/src/debug/grep-3.0-2/src/grep.c:294

This "translates" to the following callflow:

main
   grep_command_line_arg
     grepdesc
       grep
         reset # appears to return true ...
         fillbuf # (1st call in grep() ) appears to return false
           suppressible_error

However I am not sure of this result; when I repeat the procedure and 
put a
breakpoint on fillbuf(), the execution does not break on fillbuf().

(trouble is I am not "set up" for building on Cygwin; otherwise I would 
build
  my "own" (not optimized) version of grep)

Regards,
Henri




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 6 Oct 2018 20:12:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 06 16:12:47 2018
Received: from localhost ([127.0.0.1]:38873 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g8swQ-0006Tj-Tw
	for submit <at> debbugs.gnu.org; Sat, 06 Oct 2018 16:12:47 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:35174)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1g8swP-0006TU-Lm
 for 32943 <at> debbugs.gnu.org; Sat, 06 Oct 2018 16:12:46 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id B5E421616EF;
 Sat,  6 Oct 2018 13:12:39 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id Mdr20QnhGIqn; Sat,  6 Oct 2018 13:12:38 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id D03D61616F8;
 Sat,  6 Oct 2018 13:12:38 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id foMHvnuypd5S; Sat,  6 Oct 2018 13:12:38 -0700 (PDT)
Received: from [192.168.1.9] (cpe-23-242-74-103.socal.res.rr.com
 [23.242.74.103])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id A8B731616EF;
 Sat,  6 Oct 2018 13:12:38 -0700 (PDT)
Subject: Re: bug#32943: grep pattern < fifo fails on Cygwin (and MinGW), but
 not on Linux
To: Houder <houder@HIDDEN>, 32943 <at> debbugs.gnu.org
References: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <af3fdaaa-10b2-a470-e584-2ebc6891d88b@HIDDEN>
Date: Sat, 6 Oct 2018 13:12:38 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:52.0) Gecko/20100101
 Thunderbird/52.9.1
MIME-Version: 1.0
In-Reply-To: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Houder wrote:
> I applied strace to "grep . < fifo", and as far as I can tell "an lseek
> is applied to the fifo", which obviously fails.
> 
> The "lseek" occurs on Cygwin (and MinGW?), but not on Linux

That's expected, as the code needs to run lseek in some places on Cygwin where 
it's not needed on GNU/Linux.

My guess is that you've got an old version of grep on Cygwin, and need to 
upgrade to the current version. If you still have problems with the latest 
version, please investigate via GDB and/or other means exactly why grep is 
failing for you. The strace output isn't enough, unfortunately.




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at 32943 <at> debbugs.gnu.org:


Received: (at 32943) by debbugs.gnu.org; 5 Oct 2018 14:39:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 05 10:39:58 2018
Received: from localhost ([127.0.0.1]:38001 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g8RGn-0008HZ-MX
	for submit <at> debbugs.gnu.org; Fri, 05 Oct 2018 10:39:58 -0400
Received: from lb2-smtp-cloud7.xs4all.net ([194.109.24.28]:44898)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g8RGk-0008HL-L8
 for 32943 <at> debbugs.gnu.org; Fri, 05 Oct 2018 10:39:56 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:206])
 by smtp-cloud7.xs4all.net with ESMTPA
 id 8RGeg9AYSw2L88RGegeirJ; Fri, 05 Oct 2018 16:39:48 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Fri, 05 Oct 2018 16:39:48 +0200
MIME-Version: 1.0
Content-Type: multipart/mixed;
 boundary="=_40b413309e98b60cef09b2e983a677f2"
Date: Fri, 05 Oct 2018 16:39:48 +0200
From: Houder <houder@HIDDEN>
To: 32943 <at> debbugs.gnu.org
Subject: Output from strace on Cygwin
Message-ID: <25a00ce8adaa28f49ec51b3478b7be66@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfAihKGAiLhzZhx4ccWB+dHzpnDFKpOg++bvx75NEs6n9AaEtKfKxbeb6YvPN4Z7Aep21eN71kk7gbDxkw98gR7lRKVy5+iSOhvmh019DtSmVGrfe9ZxM
 XLyC1vwLfZPZ4yBrLhGbMiLtaIAHmhFigk88F8RmQFffyj4UMEnisNRT+VZP482smiD+7V337i7uD2Jr6t74Yufg9IwXc2oOUiU=
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 32943
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=_40b413309e98b60cef09b2e983a677f2
Content-Transfer-Encoding: 7bit
Content-Type: text/plain; charset=US-ASCII;
 format=flowed

Hi,

See top of file (strace.attach2pid.grep) to learn how I applied
strace.

Regards,
Henri
--=_40b413309e98b60cef09b2e983a677f2
Content-Transfer-Encoding: base64
Content-Type: text/plain;
 name=strace.attach2pid.grep
Content-Disposition: attachment;
 filename=strace.attach2pid.grep;
 size=23627
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--=_40b413309e98b60cef09b2e983a677f2--




Information forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 5 Oct 2018 10:14:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Oct 05 06:14:08 2018
Received: from localhost ([127.0.0.1]:37420 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1g8N7Y-000651-Jm
	for submit <at> debbugs.gnu.org; Fri, 05 Oct 2018 06:14:08 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47756)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <houder@HIDDEN>) id 1g8Mwp-0005pU-5E
 for submit <at> debbugs.gnu.org; Fri, 05 Oct 2018 06:03:03 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <houder@HIDDEN>) id 1g8Mwj-0002Yw-4X
 for submit <at> debbugs.gnu.org; Fri, 05 Oct 2018 06:02:57 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50 autolearn=disabled
 version=3.3.2
Received: from lists.gnu.org ([2001:4830:134:3::11]:53014)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <houder@HIDDEN>) id 1g8Mwi-0002Yo-Sr
 for submit <at> debbugs.gnu.org; Fri, 05 Oct 2018 06:02:56 -0400
Received: from eggs.gnu.org ([2001:4830:134:3::10]:57339)
 by lists.gnu.org with esmtp (Exim 4.71)
 (envelope-from <houder@HIDDEN>) id 1g8Mwi-0002Vg-1d
 for bug-grep@HIDDEN; Fri, 05 Oct 2018 06:02:56 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <houder@HIDDEN>) id 1g8Mwe-0002UV-LW
 for bug-grep@HIDDEN; Fri, 05 Oct 2018 06:02:55 -0400
Received: from lb2-smtp-cloud8.xs4all.net ([194.109.24.25]:47805)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <houder@HIDDEN>) id 1g8Mwe-0002RE-BL
 for bug-grep@HIDDEN; Fri, 05 Oct 2018 06:02:52 -0400
Received: from webmail.xs4all.nl ([IPv6:2001:888:0:22:194:109:20:199])
 by smtp-cloud8.xs4all.net with ESMTPA
 id 8MwZgKUsq0ZZE8MwZgnY6D; Fri, 05 Oct 2018 12:02:48 +0200
Received: from a83-162-234-136.adsl.xs4all.nl ([83.162.234.136])
 by webmail.xs4all.nl
 with HTTP (HTTP/1.1 POST); Fri, 05 Oct 2018 12:02:47 +0200
MIME-Version: 1.0
Content-Type: text/plain; charset=US-ASCII;
 format=flowed
Content-Transfer-Encoding: 7bit
Date: Fri, 05 Oct 2018 12:02:47 +0200
From: Houder <houder@HIDDEN>
To: bug-grep@HIDDEN
Subject: grep pattern < fifo fails on Cygwin (and MinGW), but not on Linux
Message-ID: <b669dd4f8c1715bcd288b9b68e105d02@HIDDEN>
X-Sender: houder@HIDDEN
User-Agent: XS4ALL Webmail
X-CMAE-Envelope: MS4wfEjqx1DwEylra1pZCxDoMbaFfe9bQYtvSuOHR5rK9zVBVUC+PAwEldbP0f45yEQnPhhXPG1Kd2FzjuyLmSRNzIRJQhvgOyCMBTnQek/To5YAz2EysJa1
 1CVIPxxImMq4jd/ffoUgYh8d1LONSkonC9Fyaup7+pCVqg50MrGFy0WTW8j3ZC/mk6Klp24FrThvw1KRsRBfSwwuIKOZ/Sa9+tE=
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6.x
X-Received-From: 2001:4830:134:3::11
X-Spam-Score: -4.0 (----)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Fri, 05 Oct 2018 06:14:07 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -5.0 (-----)

Hi,

Yes, I might not be following "procedure" (I do not know), but I decided
to report this failure, because I canNOT ascertain whether "the list" is
aware of this failure or not.

grep fails on Cygwin (and apparently also on MinGW), as follows:

@@ mkfifo fifo
@@ echo X > fifo & grep . < fifo # X may be omitted
[1] <some procid>
grep: (standard input): Invalid argument
[1]+  Done                    echo > fifo

This failure does not occur on Linux.

As far as I can tell, the maintainer of grep on Cygwin, hardly modifies
the source code of grep. Therefore I surmise? that the original tarball
must be in error.

I applied strace to "grep . < fifo", and as far as I can tell "an lseek
is applied to the fifo", which obviously fails.

The "lseek" occurs on Cygwin (and MinGW?), but not on Linux (as far as
I can tell, the code that is executed on Cygwin is not the same as the
one that is executed on Linux).

The failure does not occur if e.g. cut is substituted for grep.

@@ mkfifo fifo
@@ echo X > fifo & cut -f1 < fifo # X may be omitted
No error ...

Q: are you aware of this failure?

Regards,
Henri




Acknowledgement sent to Houder <houder@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-grep@HIDDEN. Full text available.
Report forwarded to bug-grep@HIDDEN:
bug#32943; Package grep. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Tue, 9 Oct 2018 11:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.